package test.test.test;
import java.io.File;
import java.io.FileInputStream;
import java.util.Hashtable;
import java.util.Properties;

import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class Subscriber implements MessageListener
{
public final static String JNDI_FACTORY="org.jboss.naming.remote.client.InitialContextFactory";
public final static String JMS_FACTORY="/ConnectionFactory";
public final static String Topic="/topic/exampleTopic";
private Connection connection;
private Session session;
private MessageConsumer receiver;
private Topic topic;
private boolean quit = false;
InitialContext initialContext = null;

public void onMessage(Message msg)
{
	try
	{
		String msgText;
		if (msg instanceof TextMessage)
		{
			msgText = ((TextMessage)msg).getText();
		}
		else
		{
			msgText = msg.toString();
		}
		
		System.out.println("::::::::::::"+msgText);
		if (msgText.equalsIgnoreCase("quit"))
		{
			synchronized(this)
			{
				quit = true;
				this.notifyAll(); // Notify main thread to quit
			}
		}
	}
	catch (JMSException jmse)
	{
		jmse.printStackTrace();
	}
}

public void init(Context ctx, String Topic) throws NamingException, JMSException
{
	try
	{
		ConnectionFactory cf = (ConnectionFactory)ctx.lookup("/ConnectionFactory");
        connection =cf.createConnection();
        connection.setClientID("Client2");
        session = connection.createSession(false,Session.AUTO_ACKNOWLEDGE);
		topic = (Topic) ctx.lookup(Topic);

		//********* Sleeping for 5's so that the message gets expired  ********
		System.out.println("Sleeping for 5's till the message expire...");
		Thread.sleep(2000);

		receiver = session.createDurableSubscriber(topic,"subscriber");
		receiver.setMessageListener(this);
		connection.start();
	}
	catch (InterruptedException jmse)
	{
		jmse.printStackTrace();
	}
}

public void close()throws JMSException
{
receiver.close();
session.close();
connection.close();
}

public static void main(String[] args) throws Exception
{
	InitialContext ic = getInitialContext();
	Subscriber qr = new Subscriber();
	qr.init(ic, Topic);
	System.out.println("JMS Ready To Receive Messages");

synchronized(qr)
{
	while (!qr.quit)
	{
		try
		{
			qr.wait();
		}
		catch (InterruptedException ie)
		{
			ie.printStackTrace();
		}
}
}
qr.close();
}

private static InitialContext getInitialContext() throws NamingException
{
	InitialContext initialContext = null;
    try
    {
  	  String jndiFilename = "client-jndi.properties";
	      File jndiFile = new File(jndiFilename);
	      Properties props = new Properties();
	      FileInputStream inStream = null;
	      try
	      {
	         inStream = new FileInputStream(jndiFile);
	         props.load(inStream);
	      }
	      finally
	      {
	         if (inStream != null)
	         {
	            inStream.close();
	         }
	      }
	     initialContext=new InitialContext(props);
	   
    }
    catch(Exception e)
    {
    	e.printStackTrace();
    }
    return initialContext;
	}
}